#ifndef     CSERIALCOM_HEADER
#define     CSERIALCOM_HEADER
//[*]-------------------------------------------------------------------------------------------------------------------------------------------------------------------[*]
#include <vcl.h>
#include <queue>
#pragma hdrstop
//[*]-------------------------------------------------------------------------------------------------------------------------------------------------------------------[*]
class CSerialCom    //  Non-Overlapped
{
    public  :
        __fastcall CSerialCom(int nPort, DWORD dwBaud);
        __fastcall ~CSerialCom();

    private :
        BOOL            m_bIsOpen;
        BOOL            m_ReadDataFlag;
        short           m_nPort;
        DWORD           m_dwBaud;
        DWORD           m_dwEvtMask;
        DWORD           m_dwBufInSize;
        DWORD           m_dwBufOutSize;
        COMMTIMEOUTS	m_timeout;  //б,  Overlapped I/O  timeout  ִ ü
        DCB				m_dcb;	    //Ʈ ۼӵ,  Ʈ, иƼ,  Ʈ, xon/off, flow control  ִ ü
        OVERLAPPED      m_osWrite; //  
        OVERLAPPED      m_osRead;

        //  Thread  Variable
        BOOL            m_bCommActive;
        HANDLE          m_hThread;
    public  :
        HANDLE          m_hComm;
        int             m_RcvCount;
        BYTE            m_RcvBuffer[4096];

    public  :
        BOOL        __fastcall CreateComm   ();
        void        __fastcall CloseComm    ();
        AnsiString  __fastcall GetLastErrMsg();
        BOOL        __fastcall IsOpen       (void);
        BOOL        __fastcall SendByteData (BYTE bData);
        BOOL        __fastcall BufferClear  ();
        void        __fastcall SetEvtMask   (DWORD EventMask);
        BOOL        __fastcall SendStrData  (BYTE *Str, int Length);
        void        __fastcall SetBufferSize(DWORD BufInSize, DWORD BufOutSize);
        void        __fastcall SetTimeOut   (DWORD ReadIntervalTimeout, DWORD ReadTotalTimeoutMultiplier,
                                             DWORD ReadTotalTimeoutConstant, DWORD WriteTotalTimeoutMultiplier, DWORD WriteTotalTimeoutConstant);

        //  ThreadFunc
        static DWORD WINAPI SerialDataWatchThread(LPVOID lpParam);
};
//[*]-------------------------------------------------------------------------------------------------------------------------------------------------------------------[*]
#endif
